import { EncodedQueryWithNulls, DecodedValueMap, SetQuery, QueryParamConfigMap } from './types';
/**
 * Convert the values in query to strings via the encode functions configured
 * in paramConfigMap
 *
 * @param paramConfigMap Map from query name to { encode, decode } config
 * @param query Query updates mapping param name to decoded value
 */
export declare function encodeQueryParams<QPCMap extends QueryParamConfigMap>(paramConfigMap: QPCMap, query: Partial<DecodedValueMap<QPCMap>>): EncodedQueryWithNulls;
/**
 * Given a query parameter configuration (mapping query param name to { encode, decode }),
 * return an object with the decoded values and a setter for updating them.
 */
export declare const useQueryParams: <QPCMap extends QueryParamConfigMap>(paramConfigMap: QPCMap) => [DecodedValueMap<QPCMap>, SetQuery<QPCMap>];
export default useQueryParams;
